<?
error_reporting(0);

//DB Variables
include("includes/BEncode.php");

$sqldb[user] = "SQL username";
$sqldb[password] = "SQL Password";
$sqldb[host] = "SQL Hostname/IP";
$sqldb[database] = "SQL Database Name";

$maxsendpeer = "50"; //Max # of peers to send to a client
$reportinterval = "1800"; // Client Report Interval Rate (sec)
$minreport = "1000"; // Min report retry
$disallowed = "Shareaza,Mozilla"; //Disallowed Client list, seperated by common no spaces between!

//Main Functions

function checkip($ip) { // Check IP Against BlackLists


}

function inputcheck() {
	global $_GET, $disallowed, $_SERVER;


	if ($_GET["peerid"] != "" && $_GET["info_hash"] && !is_numeric($_GET["down"]) && !is_numeric($_GET["up"]) && !is_numeric($_GET["left"])) {
		bterror("Malformed Data, bad client, bad!");
	}

	$list = split(",", $disallowed);
	foreach($list as $name) {
		$name = strtolower($name);
		$agent = strtolower($_SERVER["HTTP_USER_AGENT"]);
		
		$pos = strpos($agent, $name);
		if ($pos === false) { 
			//Allowed Client
		} else {
			bterror("$name is not allowed on this tracker!");
		}
	}
}
function sendpeers($hash) {
	global $_GET, $maxsendpeer, $reportinterval, $minreport;

	DbConnect();
	updatecounts($hash); //Back to bin format since update converts it, itself.
	if ($maxsendpeer < $_GET["numwant"]) {
		$count = $maxsendpeer;
	} elseif ($_GET["numwant"] == "") {
		$count = $maxsendpeer;
	} else {
		$count = $_GET["numwant"];
	}

	$result = mysql_query("select sum_seeders, sum_leechers from contents where sum_hash='$hash'");
	$counts = mysql_fetch_row($result);

	$result = mysql_query("select bt_ip, bt_pid, bt_port from bt_$hash where bt_status='seeding' ORDER BY RAND() LIMIT $count");
        if (mysql_num_rows($result) == 3) { // Under 3 Seeders, send peers also
                $result = mysql_query("select bt_ip, bt_pid, bt_port from bt_$hash ORDER BY bt_left ASC, bt_completed ASC LIMIT $count");
        }
		
	$peer["interval"] = (int)$reportinterval;
	$peer["min interval"] = (int)$minreport;
	$peer["num peers"] = (int)$counts[1];

	$i = 0;
	while($query_data = mysql_fetch_row($result)) {
		$peer["peers"][(int)$i]["ip"] = $query_data[0];
		$peer["peers"][(int)$i]["port"] = (int)$query_data[2];
		$peer["peers"][(int)$i]["peer id"] = hex2bin($query_data[1]);
		$i += 1;
	}
	if (mysql_error()) { bterror(mysql_error()); }


	if (isset($_GET["trackerid"])) {
		$peer["trackerid"] = $_GET["trackerid"];
	}

	echo BEncode($peer);
}

function scrape($hash) {
	checkip($ip);
	$hash = checkhash($hash);
	updatecounts($hash);

	$result = mysql_query("select sum_seeders, sum_leechers from contents where sum_hash='$hash'");
	$query_data = mysql_fetch_row($result);
	$hash = hex2bin($hash);
	$array["files"]["$hash"]["complete"] = (int)$query_data[0];
	$array["files"]["$hash"]["incomplete"] = (int)$query_data[1];

	echo BEncode($array);
}

function updatecounts($hash) { //Update Counts if needed
	DbConnect();
	
	$now = time();
	$result = mysql_query("select sum_stamp from contents where sum_hash='$hash' LIMIT 1");
	$query_data = mysql_fetch_row($result);
	
	if ($query_data[0] < $now) {
		//Update Scrape Counts
		$result = mysql_query("select bt_status, bt_completed from bt_$hash");
		while($query_data = mysql_fetch_row($result)) {
			if ($query_data[0] == "seeding") {
				$seed += 1;
			} else {
				$leech += 1;
			}
			if ($query_data[1] == "yes") {
				$completed += 1;
			}
		}
		$future = time() + 600;
		mysql_query("update contents set sum_stamp='$future', sum_leechers='$leech', sum_seeders='$seed', sum_complete='$completed' where sum_hash='$hash' LIMIT 1");
	}
}


function checkhash($hash) { //Check For invalid hash
        if (get_magic_quotes_gpc()) {
                $hash = stripslashes($hash);
        }

        if (strlen($hash) == 20 || strlen($hash) == 40) {
                return bin2hex($hash);
        } else {
                bterror("Invalid Hash: Length was" . strlen($hash) . " not 20 || 40");
        }
}

function remoteip() {
        global $_SERVER;

        $ip = str_replace(":ffff:", "", $_SERVER["REMOTE_ADDR"]); //Remove IPV6 Front
        return $ip;
}

function hex2bin($hexdata) {
	$bindata = "";
  	for ($i=0;$i<strlen($hexdata);$i+=2) {
		$bindata.=chr(hexdec(substr($hexdata,$i,2)));
	}

	return $bindata;
}

function updatePeerInfo($peerid, $hash, $ip, $port, $down, $up, $left, $event="") {
	checkip($ip);

	DbConnect();

	$stamp = time()+3600;

	if ((double)$left == 0) {
		$status = "seeding";
	} else {
		$status = "leeching";
	}

	if (doesTorrentExist($hash) == false) {
		InsertTorrent($hash);
	}
	
	$hash = checkhash($hash);
        $peerid = bin2hex($peerid);

	if ($event == "stopped") { // Client stopped, removed them from the peers table
		mysql_query("delete from bt_$hash where bt_pid='$peerid'");
	}
	
	if ($event == "completed") {
		mysql_query("update bt_$hash set bt_completed='yes' where bt_pid='$peerid'");
        }


	$now = time();
	mysql_query("delete from bt_$hash where bt_stamp<$now");
	unset($now);

	if ($event == "stopped") {
                mysql_query("DELETE FROM bt_$hash where bt_pid='$peerid' LIMIT 1");
		return;
        }

	$result = mysql_query("select bt_pid from bt_$hash where bt_pid='$peerid'");
	if (mysql_num_rows($result) > 0) {
		mysql_query("update bt_$hash set bt_port='$port', bt_ip='$ip', bt_uploaded='$up', bt_downloaded='$down', bt_left='$left', bt_status='$status', bt_stamp='$stamp' where bt_pid='$peerid'");
	} else {
		mysql_query("insert into bt_$hash (bt_pid, bt_ip, bt_port, bt_uploaded, bt_downloaded, bt_left, bt_status, bt_stamp) VALUES 
			('$peerid', '$ip', '$port', '$up', '$down', '$left', '$status', '$stamp')");
		if (mysql_error()) { bterror("Error Line 174:" . mysql_error()); }
	}
	if (mysql_error()) { bterror("Error Line 176 main:" . mysql_error()); }
	sendpeers($hash);
}

function doesTorrentExist($hash) { //Return true if exists, otherwise false
	DbConnect();
	
	$hash = checkhash($hash);
	$result = mysql_query("select null from contents where sum_hash='$hash'");
	if (mysql_num_rows($result) > 0) {
		return true;
	} else {
		return false;
	}
}

function InsertTorrent($hash) {
	DbConnect();

	$hash = checkhash($hash);

	if (doesTorrentExist($hash) == true) {
		return; //Torrent Exists DONT ADD AGAIN
	}

	$result = mysql_query("insert into contents (sum_hash) VALUES ('$hash')");

	$sql = "CREATE TABLE bt_$hash (
		bt_pid VARCHAR( 90 ) NOT NULL,
		bt_ip VARCHAR( 50 ) NOT NULL,
		bt_port INT( 6 ) NOT NULL,
		bt_uploaded DOUBLE NOT NULL,
		bt_downloaded DOUBLE NOT NULL,
		bt_left DOUBLE NOT NULL,
		bt_stamp DOUBLE NOT NULL,
		bt_status ENUM('leeching', 'seeding') NOT NULL,
		bt_completed enum('yes','no') NOT NULL default 'no',
		PRIMARY KEY ( bt_pid ))";

	mysql_query("$sql");
	if (mysql_error()) {
		bterror("Table creation failed, removing from contents!");
		mysql_query("DELETE From contents where sum_hash='$hash' LIMIT 1");
		bterror("$sql :\n" . mysql_error()); 
	}
}


function DbConnect() {
        global $sqldb;

        mysql_connect( $sqldb[host], $sqldb[user], $sqldb[password] ) or bterror( "Unable to connect to DB: " . mysql_error() );
        mysql_select_db( $sqldb[database] );
}

function bterror($message, $logged=true) {
	if ($logged == true) {
		$fp = fopen("messages", "a");
		fputs($fp, $message . "\n");
		fclose($fp);
		unset($fp);
	}
	$bterror["failure reason"] = $message;

	die(BEncode($bterror));
}
?>
